
{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)
-}

module GI.Atk.Objects.NoOpObjectFactory
    ( 

-- * Exported types
    NoOpObjectFactory(..)                   ,
    NoOpObjectFactoryK                      ,
    toNoOpObjectFactory                     ,
    noNoOpObjectFactory                     ,


 -- * Methods
-- ** noOpObjectFactoryNew
    noOpObjectFactoryNew                    ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Atk.Types
import GI.Atk.Callbacks
import qualified GI.GObject as GObject

newtype NoOpObjectFactory = NoOpObjectFactory (ForeignPtr NoOpObjectFactory)
foreign import ccall "atk_no_op_object_factory_get_type"
    c_atk_no_op_object_factory_get_type :: IO GType

type instance ParentTypes NoOpObjectFactory = NoOpObjectFactoryParentTypes
type NoOpObjectFactoryParentTypes = '[ObjectFactory, GObject.Object]

instance GObject NoOpObjectFactory where
    gobjectIsInitiallyUnowned _ = False
    gobjectType _ = c_atk_no_op_object_factory_get_type
    

class GObject o => NoOpObjectFactoryK o
instance (GObject o, IsDescendantOf NoOpObjectFactory o) => NoOpObjectFactoryK o

toNoOpObjectFactory :: NoOpObjectFactoryK o => o -> IO NoOpObjectFactory
toNoOpObjectFactory = unsafeCastTo NoOpObjectFactory

noNoOpObjectFactory :: Maybe NoOpObjectFactory
noNoOpObjectFactory = Nothing

type instance AttributeList NoOpObjectFactory = NoOpObjectFactoryAttributeList
type NoOpObjectFactoryAttributeList = ('[ ] :: [(Symbol, *)])

type instance SignalList NoOpObjectFactory = NoOpObjectFactorySignalList
type NoOpObjectFactorySignalList = ('[ '("notify", GObject.ObjectNotifySignalInfo), '("notify::[property]", GObjectNotifySignalInfo)] :: [(Symbol, *)])

-- method NoOpObjectFactory::new
-- method type : Constructor
-- Args : []
-- Lengths : []
-- hInArgs : []
-- returnType : TInterface "Atk" "NoOpObjectFactory"
-- throws : False
-- Skip return : False

foreign import ccall "atk_no_op_object_factory_new" atk_no_op_object_factory_new :: 
    IO (Ptr NoOpObjectFactory)


noOpObjectFactoryNew ::
    (MonadIO m) =>
    m NoOpObjectFactory
noOpObjectFactoryNew  = liftIO $ do
    result <- atk_no_op_object_factory_new
    checkUnexpectedReturnNULL "atk_no_op_object_factory_new" result
    result' <- (wrapObject NoOpObjectFactory) result
    return result'


